/*  ___   ___  ___  _   _  ___   ___   ____ ___  ____  
 * / _ \ /___)/ _ \| | | |/ _ \ / _ \ / ___) _ \|    \ 
 *| |_| |___ | |_| | |_| | |_| | |_| ( (__| |_| | | | |
 * \___/(___/ \___/ \__  |\___/ \___(_)____)___/|_|_|_|
 *                  (____/ 
 * Arduino Smart Car Tutorial Lesson 1
 * Tutorial URL http://osoyoo.com/2018/12/07/new-arduino-smart-car-lesson1/
 * CopyRight www.osoyoo.com

 * After running the code, smart car will go forward 2 seconds, then go backward 2
 * seconds, then left turn for 2 seconds then right turn for 2 seconds then stop. 
 * 
 */
#define ENA 5    //Right PWM pin connect MODEL-X ENA
#define IN1  12  //Right Motor direction pin 1 to MODEL-X IN1 
#define IN2  11  //Right Motor direction pin 2 to MODEL-X IN2
#define ENB 6    //Left PWM pin connect MODEL-X ENB
#define IN3  9   //Left Motor direction pin 1 to MODEL-X IN3 
#define IN4  10   //Left Motor direction pin 2 to MODEL-X IN4 


/*motor control*/
void go_Advance(void)  //Forward
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  analogWrite(ENB,200);
  analogWrite(ENA,200);
}
void go_Left()  //Turn left
{
  digitalWrite(IN1, HIGH);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
  analogWrite(ENB,200);
  analogWrite(ENA,200);
 
}
void go_Right()  //Turn right
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,HIGH);
  digitalWrite(IN4,LOW);
  analogWrite(ENB,200);
  analogWrite(ENA,200);

}
void go_Back(int t=0)  //Reverse
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,HIGH);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,HIGH);
  analogWrite(ENB,200);
  analogWrite(ENA,200);
  delay(t);
}
void stop_Stop()    //Stop
{
  digitalWrite(IN1, LOW);
  digitalWrite(IN2,LOW);
  digitalWrite(IN3,LOW);
  digitalWrite(IN4,LOW);
}
/*set motor speed */
void set_Motorspeed(int speed_L,int speed_R)
{
  analogWrite(ENB,speed_L); 
  analogWrite(ENA,speed_R);   
}

//Pins initialize
void init_GPIO()
{
	pinMode(IN1, OUTPUT); 
	pinMode(IN2, OUTPUT); 
	pinMode(ENB, OUTPUT);  
 
	pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT); 
  pinMode(ENA, OUTPUT); 
	stop_Stop();
}

void setup()
{
	init_GPIO();
	go_Advance();//Forward
 
  delay(2000);

  go_Back();//Reverse
 
  delay(2000);
  
  go_Left();//Turn left
 
  delay(1000);
  
  go_Right();//Turn right
 
  delay(1000);
  
  stop_Stop();//Stop

}

void loop(){
}
